Knapsack with continuous (non distinct) constraint

后端 未结 7 521
南方客
南方客 2021-02-03 12:05

I watched Dynamic Programming - Kapsack Problem (YouTube). However, I am solving a slightly different problem where the constraint is the budget, price, in double, not integer.

相关标签:
7条回答
  • 2021-02-03 12:38

    You will have to do what you said in UPDATE 1: express the budget and item prices in cents (assuming we are talking about dollars). Then we're not talking about arbitrary precision or continuous numbers. Every price (and the budget) will be an integer, it's just that that integer will represent cents.

    To make things easier let's assume the budget is $10. The problem is that the Knapsack Capacity will have to take all the values in:

    [0.00, 0.01, 0.02, 0.03, ..., 9.99, 10.00] 
    

    The values are two many. Each line of the SOLUTION MATRIX and the KEEP MATRIX will have 1001 columns so you won't be able to solve the problem by hand (if the budget is millions of dollars even a computer might have a hard time) but that is inherent to the original problem (you can't do anything about it).

    Your best bet is to use some existing code about KNAPSACK or maybe write your own (I don't advice that).

    If you can't find existing code about KNAPSACK and are familiar with Linux/Mac I suggest you install the GNU Linear Programming Kit (GLPK) and express the problem as an Integer Linear Program or a Binary Linear Program (if you're trying to solve the 0-1 Knapsack). It will solve the problem for you (plus you can use it through C, C++, Python and maybe Java if you need to). For help using GLPK check this awesome article (you'll probably need part 2, where it talks about integer variables). If you need more help with GLPK please leave a comment.

    EDIT:

    Basically, what I'm trying to say is that your constraint is not continuous, it's discrete (cents), your problem is that the budget might be too many cents so you won't be able to solve it by hand.

    Don't get intimidated because your budget might be several dollars -> several hundreds of cents. If your budget is just 18 cents your problem's size will be comparable to the one in the YouTube video. The guy in the video wouldn't be able to solve his problem either (by hand) if his knapsack size was 1800 (or even 180).

    0 讨论(0)
  • 2021-02-03 12:38

    This is not an answer to your question, but might as well be what you are looking for:

    Linear Programming

    I've used Microsoft's Solver Foundation 3 to make a simple code that solves the problem you described. It doesn't use the knapsack algorithm, but a simplex method.

    using System;
    using System.Collections.Generic;
    using System.Linq;
    using System.Text;
    using Microsoft.SolverFoundation.Common;
    using Microsoft.SolverFoundation.Services;
    
    namespace LPOptimizer
    {
        class Item
        {
            public String ItemName { get; set; }
            public double Price { get; set; }
            public double Satisfaction { get; set; }
    
            static void Main(string[] args)
            {
                //Our data, budget and items with respective satisfaction and price values
                double budget = 100.00;
                List<Item> items = new List<Item>()
                {
                    new Item(){
                        ItemName="Product_1", 
                        Price=20.1, 
                        Satisfaction=2.01
                    },
                    new Item(){
                        ItemName="Product_2", 
                        Price=1.4, 
                        Satisfaction=0.14
                    },
                    new Item(){
                        ItemName="Product_3", 
                        Price=22.1, 
                        Satisfaction=2.21
                    }
                };
    
                //variables for solving the problem.
                SolverContext context = SolverContext.GetContext();
                Model model = context.CreateModel();
                Term goal = 0; 
                Term constraint = 0; 
    
                foreach (Item i in items)
                {
                    Decision decision = new Decision(Domain.IntegerNonnegative, i.ItemName);
                    model.AddDecision(decision); //each item is a decision - should the algorithm increase this item or not?
    
                    goal += i.Satisfaction * decision; //decision will contain quantity.
                    constraint += i.Price * decision; 
                }
    
                constraint = constraint <= budget; //this now says: "item_1_price * item_1_quantity + ... + item_n_price * item_n_quantity <= budget";
    
                model.AddConstraints("Budget", constraint); 
    
                model.AddGoals("Satisfaction", GoalKind.Maximize, goal); //goal says: "Maximize: item_1_satisfaction * item_1_quantity + ... + item_n_satisfaction * item_n_quantity"
    
                Solution solution = context.Solve(new SimplexDirective());
                Report report = solution.GetReport();
                Console.Write("{0}", report);
                Console.ReadLine();
            }
        }
    }
    

    This finds the optimum max for the number of items (integers) with prices (doubles), with a budget constraint (double).

    From the code, it is obvious that you could have some items quantities in real values (double). This will probably also be faster than a knapsack with a large range (if you decide to use the *100 you mentioned).

    You can easily specify additional constraints (such as number of certain items, etc...). The code above is adapted from this MSDN How-to, where it shows how you can easily define constraints.

    Edit

    It has occurred to me that you may not be using C#, in this case I believe there are a number of libraries for linear programming in many languages, and are all relatively simple to use: You specify constraints and a goal.

    Edit2

    According to your Update 2, I've updated this code to include satisfaction.

    0 讨论(0)
  • 2021-02-03 12:43

    If you want to use floating point numbers with arbitrary precision (i.e., don't have a fixed number of decimals), and these are not fractions, dynamic programming won't work.

    The basis of dynamic programming is to store previous results of a calculation for specific inputs. Therefore, if you used floating point numbers with arbitrary precision, you would need practically infinite memory for each of the possible floating point numbers and, of course, do infinite calculations, something that is impossible and non-optimal.

    However, if these numbers have a fixed precision (as with the money, which only have two decimal numbers), you can convert these into integers by multiplying them (as you've mentioned), and then solve the knapsack problem as usual.

    0 讨论(0)
  • A question recently posted to sci.op-research offered me a welcome respite from some tedious work that I’d rather not think about and you’d rather not hear about. We know that the greedy heuristic solves the continuous knapsack problem maximizec′xs.t.a′x≤bx≤ux∈ℜ+n(1) to optimality. (The proof, using duality theory, is quite easy.) Suppose that we add what I’ll call a count constraint, yielding maximizec′xs.t.a′x≤be′x=b˜x≤ux∈ℜ+n(2) where e=(1,…,1) . Can it be solved by something other than the simplex method, such as a variant of the greedy heuristic?

    The answer is yes, although I’m not at all sure that what I came up with is any easier to program or more efficient than the simplex method. Personally, I would link to a library with a linear programming solver and use simplex, but it was amusing to find an alternative even if the alternative may not be an improvement over simplex.

    The method I’ll present relies on duality, specifically a well known result that if a feasible solution to a linear program and a feasible solution to its dual satisfy the complementary slackness condition, then both are optimal in their respective problems. I will denote the dual variables for the knapsack and count constraints λ and μ respectively. Note that λ≥0 but μ is unrestricted in sign. Essentially the same method stated below would work with an inequality count constraint (e′x≤b˜ ), and would in fact be slightly easier, since we would know a priori the sign of μ (nonnegative). The poster of the original question specified an equality count constraint, so that’s what I’ll use. There are also dual variables (ρ≥0 ) for the upper bounds. The dual problem is minimizebλ+b˜μ+u′ρs.t.λa+μe+ρ≥cλ,ρ≥0.(3)

    This being a blog post and not a dissertation, I’ll assume that (2) is feasible, that all parameters are strictly positive, and that the optimal solution is unique and not degenerate. Uniqueness and degeneracy will not cause invalidate the algorithm, but they would complicate the presentation. In an optimal basic feasible solution to (2), there will be either one or two basic variables — one if the knapsack constraint is nonbinding, two if it is binding — with every other variable nonbasic at either its lower or upper bound. Suppose that (λ,μ,ρ) is an optimal solution to the dual of (2). The reduced cost of any variable xi is ri=ci−λai−μ . If the knapsack constraint is nonbinding, then λ=0 and the optimal solution is xi=uiri>0b˜−∑rj>0ujri=00ri<0.(4) If the knapsack constraint is binding, there will be two items (j , k ) whose variables are basic, with rj=rk=0 . (By assuming away degeneracy, I’ve assumed away the possibility of the slack variable in the knapsack constraint being basic with value 0). Set xi=uiri>00ri<0(5) and let b′=b−∑i∉{j,k}aixi and b˜′=b˜−∑i∉{j,k}xi . The two basic variables are given by xj=b′−akb˜′aj−akxk=b′−ajb˜′ak−aj.(6)

    The algorithm will proceed in two stages, first looking for a solution with the knapsack nonbinding (one basic x variable) and then looking for a solution with the knapsack binding (two basic x variables). Note that the first time we find feasible primal and dual solutions obeying complementary slackness, both must be optimal, so we are done. Also note that, given any μ and any λ≥0 , we can complete it to obtain a feasible solution to (3) by setting ρi=ci−λai−μ+ . So we will always be dealing with a feasible dual solution, and the algorithm will construct primal solutions that satisfy complementary slackness. The stopping criterion therefore reduces to the constructed primal solution being feasible.

    For the first phase, we sort the variables so that c1≥⋯≥cn . Since λ=0 and there is a single basic variable (xh ), whose reduced cost must be zero, obviously μ=ch . That means the reduced cost ri=ci−λai−μ=ci−ch of xi is nonnegative for ih . If the solution given by (3) is feasible — that is, if ∑ih . Thus we can use a bisection search to complete this phase. If we assume a large value of n , the initial sort can be done in O(nlogn ) time and the remainder of the phase requires O(logn) iterations, each of which uses O(n) time.

    Unfortunately, I don’t see a way to apply the bisection search to the second phase, in which we look for solutions where the knapsack constraint is binding and λ>0 . We will again search on the value of μ , but this time monotonically. First apply the greedy heuristic to problem (1), retaining the knapsack constraint but ignoring the count constraint. If the solutions happens by chance to satisfy the count constraint, we are done. In most cases, though, the count constraint will be violated. If the count exceeds b˜ , then we can deduce that the optimal value of μ in (4) is positive; if the count falls short of b˜ , the optimal value of μ is negative. We start the second phase with μ=0 and move in the direction of the optimal value.

    Since the greedy heuristic sorts items so that c1/a1≥⋯≥cn/an , and since we are starting with μ=0 , our current sort order has (c1−μ)/a1≥⋯≥(cn−μ)/an . We will preserve that ordering (resorting as needed) as we search for the optimal value of μ . To avoid confusion (I hope), let me assume that the optimal value of μ is positive, so that we will be increasing μ as we go. We are looking for values of (λ,μ) where two of the x variables are basic, which means two have reduced cost 0. Suppose that occurs for xi and xj ; then ri=0=rj⟹ci−λai−μ=0=cj−λaj−μ(7)⟹ci−μai=λ=cj−μaj. It is easy to show (left to the reader as an exercise) that if (c1−μ)/a1≥⋯≥(cn−μ)/an for the current value of μ , then the next higher (lower) value of μ which creates a tie in (7) must involve consecutive a consecutive pair of items (j=i+1 ). Moreover, again waving off degeneracy (in this case meaning more than two items with reduced cost 0), if we nudge μ slightly beyond the value at which items i and i+1 have reduced cost 0, the only change to the sort order is that items i and i+1 swap places. No further movement in that direction will cause i and i+1 to tie again, but of course either of them may end up tied with their new neighbor down the road.

    The second phase, starting from μ=0 , proceeds as follows. For each pair (i,i+1) compute the value μi of μ at which (ci−μ)/ai=(ci+1−μ)/ai+1 ; replace that value with ∞ if it is less than the current value of μ (indicating the tie occurs in the wrong direction). Update μ to miniμi , compute λ from (7), and compute x from (5) and (6). If x is primal feasible (which reduces to 0≤xi≤ui and 0≤xi+1≤ui+1 ), stop: x is optimal. Otherwise swap i and i+1 in the sort order, set μi=∞ (the reindexed items i and i+1 will not tie again) and recompute μi−1 and μi+1 (no other μj are affected by the swap).

    If the first phase did not find an optimum (and if the greedy heuristic at the start of the second phase did not get lucky), the second phase must terminate with an optimum before it runs out of values of μ to check (all μj=∞ ). Degeneracy can be handled either with a little extra effort in coding (for instance, checking multiple combinations of i and j in the second phase when three-way or higher ties occur) or by making small perturbations to break the degeneracy.

    0 讨论(0)
  • 2021-02-03 12:47

    The answers are not quite correct.

    You can implement a dynamic programm that solves the knapsack problem with integer satisfaction and arbitrary real number prizes like doubles.

    First the standard solution of the problem with integer prizes:

    Define K[0..M, 0..n] where K[j, i] = optimal value of items in knapsack of size j, using only items 1, ..., i
    
    for j = 0 to M do K[j,0] = 0
    for i = 1 to n do
        for j = 0 to M do
            //Default case: Do not take item i
            K[j,1] = K[j, i-1]
            if j >= w_i and v_i+K[j-w, i-1] > K[j, i] then
                //Take item i
                K[j,i] = v_i + K[j-w_i, i-1]
    

    This creates a table where the solution can be found by following the recursion for entry K[M, n].

    Now the solution for the problem with real number weight:

    Define L[0..S, 0..N] where L[j, i] = minimal weight of items in knapsack of total value >= j, using only items 1, ..., i
    and S = total value of all items
    
    for j = 0 to S do L[j, 0] = 0
    for i = 0 to n do
        for j = 0 to S do
            //Default case: Do not take item i
            L[j,i] = L[j, i-1]
            if j >= v_i and L[j-v_i, i-1] + w_i < L[j, i] then
                //Take item i
                L[j, i] = L[j -v_i, i-1] + w_i
    

    The solution can now be found similiar to the other version. Instead of using the weight as first dimension we now use the total value of the items that lead to the minimal weight. The code has more or less the same runtime O(S * N) whereas the other has O(M * N).

    0 讨论(0)
  • 2021-02-03 12:55

    The answer to your question depends on several factors:

    1. How large is the value of constraint (if scaled to cants and converted to integers).
    2. How many items are there.
    3. What kind of knapsack problem is to be solved
    4. What is required precision.

    If you have very large constraint value (much more than millions) and very many items (much more than thousands)

    Then the only option is Greedy approximation algorithm. Sort the items in decreasing order of value per unit of weight and pack them in this order.

    If you want to use a simple algorithm and do not require high precision

    Then again try to use greedy algorithm. "Satisfaction value" itself may be very rough approximation, so why bother inventing complex solutions when simple approximation may be enough.

    If you have very large (or even continuous) constraint value but pretty small number of items (less than thousands)

    Then use branch and bound approach. You don't need to implement it from scratch. Try GNU GLPK. Its branch-and-cut solver is not perfect, but may be enough to solve small problems.

    If both constraint value and number of items are small

    Use any approach (DP, branch and bound, or just brute-force).

    If constraint value is pretty small (less than millions) but there are too many (like millions) items

    Then DP algorithms are possible.

    Simplest case is the unbounded knapsack problem when there is no upper bound on the number of copies of each kind of item. This wikipedia article contains a good description how to simplify the problem: Dominance relations in the UKP and how to solve it: Unbounded knapsack problem.

    More difficult is the 0-1 knapsack problem when you can pack each kind of item only zero times or one time. And the bounded knapsack problem, allowing to pack each kind of item up to some integer limit times is even more difficult. Internet offers lots of implementations for these problems, there are several suggestions in the same article. But I don't know which one is good or bad.

    0 讨论(0)
提交回复
热议问题